# Copyright (c) 2019-2023 Andrew Marx. All rights reserved.
# Licensed under GPLv3.0. See LICENSE file in the project root for details.

#' Simple split corridor example
#'
#' A fabricated dataset of a simple split corridor. Contains resistance,
#' absorption, and occupancy data.
#'
#' @format A list of three matrices. Matrices have 34 rows and 202 columns.
#'
#' @source Fletcher et al (2019) <doi:10.1111/ele.13333>
"example_split_corridor"


#' Simple maze example
#'
#' A simple maze layout.
#'
#' @format A 20x20 matrix.
#'
#' @source Generated for Maze Example vignettes
"example_maze"

#' Toy resistance data
#'
#' Toy resistance data used in a workshop at IALE 2021
#'
#' @format A 10x10 matrix.
#'
#' @source IALE 2021 workshop
"example_toy_res"
